require "mkmf"

def have_librarys(*lib)
  printf "checking librarys lib%s... ", lib.join(", lib")
  STDOUT.flush

  libs = "-l" + lib.join(" -l") + " " + $libs
  r = try_link(<<"SRC", libs)
int main() { return 0; }
SRC
  unless r
    print "no\n"
    return false
  end

  $libs = libs
  print "yes\n"
  return true
end

case RUBY_PLATFORM
when /linux/
  if with_config("ifort")
    dir_config("--with-ifort","/usr/include","/opt/intel/lib/intel64")
    if ! have_librarys("ifcore", "imf", "intlc") then
      warn "cannot find library file for ifort\n"
      warn "ruby extconf.rb --with-ifort-lib=(path of libifcore.so)\n"
      exit 1
    end
    have_librarys("svml","guide")
  elsif with_config("ffc32")
    dir_config("--with-ffc","/usr/FFC/include","/usr/FFC/lib")
    if ! have_librarys("fj9f6","fj9i6","fj9e6","fccx86_6a") then
      warn "cannot find library file for ffc32\n"
      warn "ruby extconf.rb --with-ffc32-lib=(path of libfj9f6.so)\n"
      exit 1
    end
  elsif with_config("ffc64")
    dir_config("--with-ffc64","/usr/include","/usr/lib")
    if ! have_librarys("fj90f", "fj90i", "rt", "elf")
      warn "cannot find library file for ffc64\n"
      warn "ruby extconf.rb --with-ffc64-lib=(path of libfj90f.so)\n"
      exit 1
    end
  elsif with_config("gfortran")
    dir_config("--with-gfortran")
    if ! have_librarys("gfortran") then
      warn "cannot find library file for gfortran\n"
      warn "ruby extconf.rb --with-gfortran-lib=(path of libgfortran.so)\n"
      exit 1
    end
  else
      warn "at this moment, only ifort, ffc and gfortran are supported\n"
      warn "ruby extconf.rb --with-ifort, --with-ffc32, --with-ffc64, or --with-gfortran\n"
      exit 1
  end
else
  warn "unsuported platform: "+RUBY_PLATFORM
  exit 1
end

  dir_config('--with-narray',$sitearchdir,$sitearchdir)
  if ! have_header("narray.h")
    STDERR.print "cannot find narray header file\n"
    STDERR.print "ruby extconf.rb --with-narray-include=...\n"
    exit 1
  end

  libname = arg_config("--with-ispack-name","isp")

  dir_config("--with-ispack","/usr/include","/usr/lib")
  if ! have_library(libname) then
    STDERR.print "cannot find library file for lib#{libname}.a\n"
    STDERR.print "ruby extconf.rb --with-ispack-name=(name of library) --with-ispack-lib=(path of library)\n"
    exit 1
  end

create_makefile("ispack_raw")
